<template>
  <div>
    <div class="hero is-info">
      <div class="hero-body">
        <form class="login" @submit.prevent="uploadPipeline">
          <h1 class="title has-text-centered is-size-2">pipeline selection</h1>
          <div class="columns is-centered">
            <div class="column is-half">
              <div class="notification is-light">
                <figure class="image container is-64x64">
                  <img src="../assets/logo.png" />
                </figure>
                <div class="field">
                  <label class="label">repository url</label>
                  <li v-for="item in repositories" :key="item">{{ item }}</li>
                </div>
                <div class="columns is-centered">
                  <div class="field has-addons">
                    <p class="control has-icons-left">
                      <input
                        class="input"
                        required
                        v-model="repo"
                        v-validate="'min:3|max:100'"
                        name="urlRepository"
                        type="text"
                        placeholder="you're repository url"
                      />
                      <span class="icon is-small is-left">
                        <!--todo-->
                        <font-awesome-icon icon="code-branch" />
                      </span>
                    </p>
                    <div class="control">
                      <a class="button is-info" v-on:click="addRepo()">Add</a>
                    </div>
                  </div>
                </div>
                <div class="field">
                  <label class="label">select you're pipeline</label>
                  <div class="columns">
                    <div class="column">
                      <label class="checkbox">
                        <input type="checkbox" v-model="pipeline_1" />
                      </label>
                      <pipeline_1 />
                    </div>
                    <div class="column">
                      <label class="checkbox">
                        <input type="checkbox" v-model="customPipeline" />
                        <customPipeline />
                      </label>
                    </div>
                  </div>
                </div>
                <button
                  class="button is-primary is-rounded is-medium"
                  type="submit"
                >
                  Launch
                </button>
                <div class="field">
                  <div v-if="problems" class="help is-danger">
                    {{ message }}
                  </div>
                </div>
              </div>
            </div>
          </div>
        </form>
      </div>
    </div>
  </div>
</template>

<script>
import pipeline_1 from "./pipeline/pipeline_1";
import customPipeline from "./pipeline/customPipeline";

export default {
  name: "newPipeline",
  data: function() {
    return {
      pipeline: "",
      message: "",
      repo: "",
      problems: false,
      pipeline_1: false,
      customPipeline: false,
      repositories: []
    };
  },
  methods: {
    addRepo() {
      console.log("addrepo");
      this.$validator.validate().then(isValid => {
        if (isValid) {
          this.repositories.push(this.repo);
        } else {
          this.problems = true;
          console.log("pick problem");
          this.message = "error";
        }
      });
    },
    uploadPipeline() {
      console.log("uploadPipeline");
      this.$store.dispatch("pipeline/upload", this.pipeline).then(
        () => {
          //todo
          //this.$router.push("")
        },
        error => {
          this.message =
            (error.response && error.response.data) ||
            error.message ||
            error.toString();
        }
      );
    }
  },
  components: {
    pipeline_1,
    customPipeline
  }
};
</script>
